//
// Created by robtor on 05.01.23.
//

#include "Menu_Entry_Type_Time.h"

namespace floatpump {
    namespace menu {
        std::string Menu_Entry_Type_Time::toString() {
            switch(m_entered) {
                case 0:
                    return std::string(" " + std::to_string(m_hour) + ":" + std::to_string(m_minute) + ":" + std::to_string(m_second)); break;
                case 1:
                    return std::string("#" + std::to_string(m_hour) + ":" + std::to_string(m_minute) + ":" + std::to_string(m_second)); break;
                case 2:
                    return std::string(" " + std::to_string(m_hour) + "#" + std::to_string(m_minute) + ":" + std::to_string(m_second)); break;
                case 3:
                    return std::string(" " + std::to_string(m_hour) + ":" + std::to_string(m_minute) + "#" + std::to_string(m_second)); break;
            }
            return std::string();
        }

        void Menu_Entry_Type_Time::u_press() {
            if(m_entered < 3) {
                m_entered++;
            } else {
                m_entered = 0;
            }
        }

        void Menu_Entry_Type_Time::u_increase(uint16_t steps) {
            switch(m_entered) {
                case 1:
                    (m_hour < 23) ? m_hour++ : m_hour = 0; break;
                case 2:
                    (m_minute < 59) ? m_minute++ : m_minute = 0; break;
                case 3:
                    (m_second < 59) ? m_second++ : m_second = 0; break;
            }
        }

        void Menu_Entry_Type_Time::u_decrease(uint16_t steps) {
            switch(m_entered) {
                case 1:
                    (m_hour > 0) ? m_hour-- : m_hour = 23; break;
                case 2:
                    (m_minute > 0) ? m_minute-- : m_minute = 59; break;
                case 3:
                    (m_second > 0) ? m_second-- : m_second = 59; break;
            }
        }

        bool Menu_Entry_Type_Time::isEntered() {
            if(m_entered > 0) {
                return true;
            } else {
                return false;
            }
        }
    } // floatpump
} // menu